const { assert } = require("chai")
const { xMap } = require("./index")

describe("xMap", () => {

  it("Should be a function", () => {
    assert.isFunction(xMap)
  })


  it("get a string", () => {
    const map = new xMap()
    map.set(0, "String 0")
    assert.strictEqual(map.get(0), "String 0")
  })

  it("get a number", () => {
    const map = new xMap()
    map.set(0, 0)
    assert.strictEqual(map.get(0), 0)
  })

  it("get by object", () => {
    const map = new xMap()
    map.set({ a: 1 }, "Set a to 1")
    assert.strictEqual(map.get({ a: 1 }), "Set a to 1")
  })

  it("get by partial object", () => {
    const map = new xMap()
    map.set({ a: 1, b: 2 }, 8080)
    assert.strictEqual(map.get({ b: 2 }), 8080)
  })

  it("get array of results by partial object", () => {
    const map = new xMap()
    map.set({ a: 1, b: 2 }, 1001)
    map.set({ b: 2 }, 1002)
    assert.strictEqual(map.get({ b: 2 })[0], 1001)
    assert.strictEqual(map.get({ b: 2 })[1], 1002)
  })

})